<?
/**
 * gestione degli oggetti moas
 *
 * composizione, caricamento dai files
 * azioni associate ad essi
 * @package MoasObjects
 **/


/**
 * @name ProcessPost
 * processa i post sostituendo il carattere "_" con il carattere "."
 * poich i "." vengono convertiti "_" dal server
**/
function ProcessPost()
{

	foreach ($_GET as $key => $value)
	{
		if (strstr($key,"_"))
		{
			unset ($_GET[$key]);
			$key=str_replace("_",":",$key);
			$_GET[$key]=$value;
		}
	}

	foreach ($_POST as $key => $value)
	{
		if (strstr($key,"_"))
		{
			unset ($_POST[$key]);
			$key=str_replace("_",":",$key);
			$_POST[$key]=$value;
		}
	}
}

/**
* @name post2instance
* @param &object $instance
* associa all' istanza i valori che riceve in post
**/
function post2instance (&$instance)
{

	foreach ($_GET as $key => $value)
	{

		$key=str_replace("_",":",$key);

		if (isset($instance[$key]))
		{
			$instance[$key]->__value=stripslashes($value);
		}
	}


	foreach ($_POST as $key => $value)
	{

		$key=str_replace("_",":",$key);

		if (isset($instance[$key]))
		{
			$instance[$key]->__value=stripslashes($value);
			//echo "<br />$key=$value";
		}
	}
}


/**
* @name get_xml_object_from_file
* @param string name : nome dell' oggetto
* @return torna l'XML dell' oggetto cercato
**/
function get_xml_object_from_file ($objectname,$path=".")
{
	$filexml="$path/objects/$objectname.xml";

	if (file_exists($filexml))
	{
		return file_get_contents($filexml);
	}
	return  null;
}


/**
* @name get_xml_object_from_file
* @param string name : nome dell' oggetto
* @return torna l'XML dell' oggetto cercato
**/
function get_xml_instance_from_file ($objectname,$path=".")
{
	$filexml="$path/objects/$objectname.xml";

	if (file_exists($filexml))
	{
		return new MoasInstance(file_get_contents($filexml));
	}
	return  null;
}



/**
 * Torna un istanza memorizzata nella sessione
 * @name GetMoasInstance
 * @param string nome dell' istanza
 * @return istanza
**/

function GetMoasInstance($name)
{
	return (isset($_SESSION[$name]) && is_object($_SESSION[$name])) ? $_SESSION[$name] : null;
}


?>