<?

//includiamo la libreria NuSOAP
require_once ("nusoap.php");

//definiamo il nostro namespace privato come abbiamo fatto anche nel capitolo WSDL
define("NAMESPACE", "http://www.teammosaico.biz/namespaces/xmlobjects");

//creiamo un istanza del server fornito da nusoap
$server = new soap_server;

//disattiviamo il debug
$server->debug_flag = false;

//cominciamo a configurare un documento WSDL (che sar elaborato da NuSOAP) per il nostro Web service
$server->configureWSDL('SapServer', NAMESPACE); // <-- diamo un nome al Web service ed impostiamo il nostro namespace
$server->wsdl->schemaTargetNamespace = NAMESPACE; // <-- impostiamo il nostro namespace anche come target dello schema WSDL (come abbiamo fatto nell'esempio WSDL)

//--------DEFINIZIONE STRUTTURA DI RITORNO ----------------------------
//adesso che abbiamo definito le parti personali del WSDL passiamo a definire i tipi, di tutto il resto si occuper la libreria NuSOAP
$server->wsdl->addComplexType(// <-- aggiungiamo al WSDL un tipo complesso (li abbiamo gi visti in precedenza)
'retstruct', // <- con il primo argomento impostiamo il nome
'complexType', // <-- con il secondo il tipo, naturalmente complesso ;)
'struct', // <-- indichiamo a NuSOAP il tipo php che useremo per questo elemento
'all', //<-- qui impostiamo l'indicatore di ordine
'', // <-- attraverso questo argomento si pu impostare una restrizione ma noi non ne abbiamo bisogno
array (// <-- con questo array inseriamo gli elementi child (figli) che faranno parte dell'elemento utente
	'sqlreq' => array (
		'name' => 'sqlreq',
		'type' => 'xsd:string'
	), // <- sono elementi di tipo semplice, impostiamo per loro il nome ed il tipo
	'result' => array (
		'name' => 'result',
		'type' => 'xsd:string'
	), // N.B. in NuSOAP il namespace per i tipi base  xsd, nei nostri esempi precedenti noi avevamo usato xs
	'client' => array (
		'name' => 'client',
		'type' => 'xsd:string'
	),
	
));

//--------DICHIARAZIONE FUNZIONI ------------------------------------------->
$server->register('evalxmlquery', //<-nome funzione
array (
	'sqltext' => 'xsd:string'
), //<-questo array contiene gli elementi da ricevere in input per l'operazione, come chiave il nome dell'elemento da ricevere ed il suo tipo come valore
array (
	'return' => 'tns:retstruct'
), //<-- stessa cosa per questo array che invece rappresenta l'output dell'operazione. n.b. in NuSOAP i tipi da noi creati vengono inseriti nel namespace "tns"
NAMESPACE // <-- ancora una volta specifichiamo il namespace
);

//ora che abbiamo registrato un operazione per il Web service bisogna anche implementarla ;)  estramamente semplice!
function evalxmlquery($sqltext)
{ //<- n.b. il nome della funzione dev'essere uguale al nome che abbiamo registrato in precedenza per l'operazione
	require_once ("../../include/database.php");
	$connid = opendb();
	$recordset = mysql_query($sqltext);
	$records = array ();
	while ($d = mysql_fetch_assoc($recordset))
	{
		$records[] = $d;
	}

	$ip = $_SERVER['REMOTE_HOST'];

	$res = recordtoxml($records);
	$value = Array (
		'sqlreq' => $sqltext,
		'result' => htmlentities("<responsedata>" . $res . "\n</reaponsedata>"
	), 'client' => $ip);
	return $value;
}

//<--------DICHIARAZIONE FUNZIONI -------------------------------------------

$HTTP_RAW_POST_DATA = isset ($GLOBALS['HTTP_RAW_POST_DATA']) ? $GLOBALS['HTTP_RAW_POST_DATA'] : '';
$server->service($HTTP_RAW_POST_DATA);
exit ();
function recordtoxml($recordset)
{
	$res = "";
	foreach ($recordset as $k => $v)
	{
		$res .= "\n<row>";
		foreach ($v as $key => $value)
		{
			$res .= "\n\t<" . $key . ">" . $value . "</" . $key . ">";
		}
		$res .= "\n</row>";

	}
	return $res;
}
?>